/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 19 "../src/vlog/vlog-parse.y"

#include "util.h"
#include "diag.h"
#include "ident.h"
#include "lib.h"
#include "object.h"
#include "scan.h"
#include "vlog/vlog-node.h"
#include "vlog/vlog-phase.h"

#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#define YYLTYPE loc_t
#define YYSTYPE yylval_t
#define YYTOKENTYPE token_t

#define YYEMPTY -2
#define YYEOF tEOF
#define YYerror -3
#define YYUNDEF tERROR

#define yylex processed_yylex

typedef struct _node_list node_list_t;

struct _node_list {
   node_list_t *next;
   node_list_t *tail;
   vlog_node_t  value;
};

static void yyerror(const char *s);

static void node_list_append(node_list_t **l, vlog_node_t v);
static void node_list_concat(node_list_t **a, node_list_t *b);
static node_list_t *node_list_single(vlog_node_t v);
static void node_list_free(node_list_t *l);

#define YYLLOC_DEFAULT(Current, Rhs, N) {                            \
   if (N) {                                                          \
      (Current) = get_loc(YYRHSLOC(Rhs, 1).first_line,               \
                          YYRHSLOC(Rhs, 1).first_column,             \
                          YYRHSLOC(Rhs, N).first_line +              \
                          YYRHSLOC(Rhs, N).line_delta,               \
                          YYRHSLOC(Rhs, N).first_column +            \
                          YYRHSLOC(Rhs, N).column_delta,             \
                          YYRHSLOC(Rhs, N).file_ref);                \
   }                                                                 \
   else {                                                            \
      (Current) = YYRHSLOC(Rhs, 0);                                  \
   }                                                                 \
 }

static vlog_node_t root;

static void add_port(vlog_node_t module, vlog_node_t port)
{
   if (vlog_kind(port) == V_PORT_DECL) {
      // Verilog-2001 style port declaration
      vlog_node_t ref = vlog_new(V_REF);
      vlog_set_loc(ref, vlog_loc(port));
      vlog_set_ident(ref, vlog_ident(port));
      vlog_set_ref(ref, port);

      vlog_add_port(module, ref);
      vlog_add_decl(module, port);
   }
   else {
      assert(vlog_kind(port) == V_REF);
      vlog_add_port(module, port);
   }
}

static bool is_decl(vlog_node_t v)
{
   switch (vlog_kind(v)) {
   case V_PORT_DECL:
   case V_NET_DECL:
      return true;
   default:
      return false;
   }
}

#line 159 "src/vlog/vlog-parse.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    tEOF = 0,                      /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 384,                 /* "invalid token"  */
    tID = 200,                     /* "identifier"  */
    tSYSTASK = 383,                /* "system task identifier"  */
    tSTRING = 229,                 /* "string"  */
    tUNSIGNED = 359,               /* "unsigned number"  */
    tMODULE = 350,                 /* "module"  */
    tENDMODULE = 351,              /* "endmodule"  */
    tINPUT = 352,                  /* "input"  */
    tOUTPUT = 353,                 /* "output"  */
    tREG = 354,                    /* "reg"  */
    tALWAYS = 336,                 /* "always"  */
    tINITIAL = 357,                /* "initial"  */
    tPOSEDGE = 355,                /* "posedge"  */
    tNEGEDGE = 356,                /* "negedge"  */
    tBEGIN = 211,                  /* "begin"  */
    tEND = 203,                    /* "end"  */
    tLE = 294,                     /* "<="  */
    tWIRE = 358,                   /* "wire"  */
    tASSIGN = 227                  /* "assign"  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define tEOF 0
#define YYerror 256
#define YYUNDEF 384
#define tID 200
#define tSYSTASK 383
#define tSTRING 229
#define tUNSIGNED 359
#define tMODULE 350
#define tENDMODULE 351
#define tINPUT 352
#define tOUTPUT 353
#define tREG 354
#define tALWAYS 336
#define tINITIAL 357
#define tPOSEDGE 355
#define tNEGEDGE 356
#define tBEGIN 211
#define tEND 203
#define tLE 294
#define tWIRE 358
#define tASSIGN 227

/* Value type.  */

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;

int yyparse (void);



/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_tID = 3,                        /* "identifier"  */
  YYSYMBOL_tSYSTASK = 4,                   /* "system task identifier"  */
  YYSYMBOL_tSTRING = 5,                    /* "string"  */
  YYSYMBOL_tUNSIGNED = 6,                  /* "unsigned number"  */
  YYSYMBOL_tMODULE = 7,                    /* "module"  */
  YYSYMBOL_tENDMODULE = 8,                 /* "endmodule"  */
  YYSYMBOL_tINPUT = 9,                     /* "input"  */
  YYSYMBOL_tOUTPUT = 10,                   /* "output"  */
  YYSYMBOL_tREG = 11,                      /* "reg"  */
  YYSYMBOL_tALWAYS = 12,                   /* "always"  */
  YYSYMBOL_tINITIAL = 13,                  /* "initial"  */
  YYSYMBOL_tPOSEDGE = 14,                  /* "posedge"  */
  YYSYMBOL_tNEGEDGE = 15,                  /* "negedge"  */
  YYSYMBOL_tBEGIN = 16,                    /* "begin"  */
  YYSYMBOL_tEND = 17,                      /* "end"  */
  YYSYMBOL_tLE = 18,                       /* "<="  */
  YYSYMBOL_tWIRE = 19,                     /* "wire"  */
  YYSYMBOL_tASSIGN = 20,                   /* "assign"  */
  YYSYMBOL_21_ = 21,                       /* ';'  */
  YYSYMBOL_22_ = 22,                       /* '('  */
  YYSYMBOL_23_ = 23,                       /* ')'  */
  YYSYMBOL_24_ = 24,                       /* ','  */
  YYSYMBOL_25_ = 25,                       /* '['  */
  YYSYMBOL_26_ = 26,                       /* ':'  */
  YYSYMBOL_27_ = 27,                       /* ']'  */
  YYSYMBOL_28_ = 28,                       /* '='  */
  YYSYMBOL_29_ = 29,                       /* '@'  */
  YYSYMBOL_YYACCEPT = 30,                  /* $accept  */
  YYSYMBOL_description = 31,               /* description  */
  YYSYMBOL_32_1 = 32,                      /* $@1  */
  YYSYMBOL_module_declaration = 33,        /* module_declaration  */
  YYSYMBOL_module_port_list_opt = 34,      /* module_port_list_opt  */
  YYSYMBOL_list_of_ports = 35,             /* list_of_ports  */
  YYSYMBOL_port = 36,                      /* port  */
  YYSYMBOL_port_reference = 37,            /* port_reference  */
  YYSYMBOL_list_of_port_declarations = 38, /* list_of_port_declarations  */
  YYSYMBOL_port_declaration = 39,          /* port_declaration  */
  YYSYMBOL_module_item_list_opt = 40,      /* module_item_list_opt  */
  YYSYMBOL_module_item_list = 41,          /* module_item_list  */
  YYSYMBOL_module_item = 42,               /* module_item  */
  YYSYMBOL_module_or_generate_item = 43,   /* module_or_generate_item  */
  YYSYMBOL_module_or_generate_item_declaration = 44, /* module_or_generate_item_declaration  */
  YYSYMBOL_net_declaration = 45,           /* net_declaration  */
  YYSYMBOL_net_type = 46,                  /* net_type  */
  YYSYMBOL_list_of_net_identifiers = 47,   /* list_of_net_identifiers  */
  YYSYMBOL_continuous_assign = 48,         /* continuous_assign  */
  YYSYMBOL_list_of_net_assignments = 49,   /* list_of_net_assignments  */
  YYSYMBOL_net_assignment = 50,            /* net_assignment  */
  YYSYMBOL_always_construct = 51,          /* always_construct  */
  YYSYMBOL_initial_construct = 52,         /* initial_construct  */
  YYSYMBOL_statement = 53,                 /* statement  */
  YYSYMBOL_statement_or_null = 54,         /* statement_or_null  */
  YYSYMBOL_list_of_statements = 55,        /* list_of_statements  */
  YYSYMBOL_system_task_enable = 56,        /* system_task_enable  */
  YYSYMBOL_seq_block = 57,                 /* seq_block  */
  YYSYMBOL_nonblocking_assignment = 58,    /* nonblocking_assignment  */
  YYSYMBOL_procedural_timing_control_statement = 59, /* procedural_timing_control_statement  */
  YYSYMBOL_delay_or_event_control = 60,    /* delay_or_event_control  */
  YYSYMBOL_event_control = 61,             /* event_control  */
  YYSYMBOL_event_expression = 62,          /* event_expression  */
  YYSYMBOL_lvalue = 63,                    /* lvalue  */
  YYSYMBOL_expression = 64,                /* expression  */
  YYSYMBOL_list_of_expressions = 65,       /* list_of_expressions  */
  YYSYMBOL_string = 66,                    /* string  */
  YYSYMBOL_primary = 67,                   /* primary  */
  YYSYMBOL_number = 68,                    /* number  */
  YYSYMBOL_decimal_number = 69,            /* decimal_number  */
  YYSYMBOL_hierarchical_identifier = 70,   /* hierarchical_identifier  */
  YYSYMBOL_identifier = 71,                /* identifier  */
  YYSYMBOL_external_identifier = 72        /* external_identifier  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   120

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  30
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  43
/* YYNRULES -- Number of rules.  */
#define YYNRULES  72
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  121

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   384


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      22,    23,     2,     2,    24,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    26,    21,
       2,    28,     2,     2,    29,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    25,     2,    27,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     2,     2,    17,     2,     2,     2,     2,     2,     2,
       2,    16,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    20,     2,     5,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    18,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    12,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       7,     8,     9,    10,    11,    14,    15,    13,    19,     6,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     4,     2
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   162,   162,   162,   163,   167,   193,   194,   195,   198,
     203,   206,   209,   218,   229,   234,   238,   246,   254,   265,
     266,   270,   275,   279,   280,   288,   289,   290,   291,   295,
     299,   303,   310,   314,   323,   335,   339,   340,   347,   357,
     370,   382,   383,   384,   385,   389,   390,   394,   399,   407,
     415,   429,   438,   451,   461,   472,   475,   478,   485,   492,
     501,   509,   510,   514,   519,   526,   536,   542,   545,   548,
     558,   561,   569
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "\"identifier\"",
  "\"system task identifier\"", "\"string\"", "\"unsigned number\"",
  "\"module\"", "\"endmodule\"", "\"input\"", "\"output\"", "\"reg\"",
  "\"always\"", "\"initial\"", "\"posedge\"", "\"negedge\"", "\"begin\"",
  "\"end\"", "\"<=\"", "\"wire\"", "\"assign\"", "';'", "'('", "')'",
  "','", "'['", "':'", "']'", "'='", "'@'", "$accept", "description",
  "$@1", "module_declaration", "module_port_list_opt", "list_of_ports",
  "port", "port_reference", "list_of_port_declarations",
  "port_declaration", "module_item_list_opt", "module_item_list",
  "module_item", "module_or_generate_item",
  "module_or_generate_item_declaration", "net_declaration", "net_type",
  "list_of_net_identifiers", "continuous_assign",
  "list_of_net_assignments", "net_assignment", "always_construct",
  "initial_construct", "statement", "statement_or_null",
  "list_of_statements", "system_task_enable", "seq_block",
  "nonblocking_assignment", "procedural_timing_control_statement",
  "delay_or_event_control", "event_control", "event_expression", "lvalue",
  "expression", "list_of_expressions", "string", "primary", "number",
  "decimal_number", "hierarchical_identifier", "identifier",
  "external_identifier", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-66)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
       7,   -66,     9,    15,   -66,    11,   -66,   -66,    20,    64,
      28,   -66,    11,     8,    70,   -66,   -66,    83,   -66,   -66,
      79,   -66,    11,   -66,   -66,    26,   -66,    87,    56,    56,
     -66,    26,    43,    62,    79,   -66,   -66,   -66,   -66,     2,
     -66,   -66,   -66,   -66,   -66,   -66,   -66,    89,    22,    35,
     -66,   -66,   -66,    45,   -66,    29,   -66,    77,   -66,   -66,
     -66,    58,   -66,    75,   -66,   -66,   -66,    18,    80,   -66,
     -66,    18,    26,   -66,    36,    72,   -66,   -66,   -66,   -66,
      18,   -66,    26,    18,   -66,   -66,    54,   -66,   -66,   -66,
     -66,   -66,   -66,    26,   -66,    90,    56,   -66,   -66,    18,
      18,    85,   -66,   -66,   -66,   -66,    18,   -66,    91,    18,
      52,   -66,   -66,   -66,    73,   -66,   -66,   -66,    26,    81,
     -66
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     4,     0,     0,     1,     0,     3,    72,     8,     0,
       0,    71,     0,     0,     0,    10,    11,     0,    15,    12,
      20,    16,     0,    17,     7,     0,     6,     0,     0,     0,
      32,     0,     0,     0,    19,    22,    23,    25,    29,     0,
      28,    26,    27,    18,     9,    14,    13,     0,     0,     0,
      39,    44,    43,     0,    41,     0,    55,     0,    60,    70,
      40,     0,    36,     0,    24,     5,    21,     0,     0,    34,
      49,     0,     0,    48,     0,     0,    42,    46,    45,    54,
       0,    35,     0,     0,    65,    69,     0,    62,    61,    67,
      68,    66,    30,     0,    64,     0,     0,    51,    47,     0,
       0,     0,    57,    53,    37,    38,     0,    33,     0,     0,
       0,    58,    59,    56,     0,    50,    63,    52,     0,     0,
      31
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -66,   -66,   -66,   -66,   -66,   -66,    92,   -66,   -66,     4,
     -66,   -66,    82,   -66,   -66,   -66,   -66,    -3,   -66,   -66,
      37,   -66,   -66,   -27,   -66,    24,   -66,   -66,   -66,   -66,
     -66,   -66,   -66,   -28,   -65,   -66,   -66,   -66,   -66,   -66,
     -63,    -9,    49
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     2,     3,     6,    10,    14,    15,    16,    17,    32,
      33,    34,    35,    36,    37,    38,    39,    68,    40,    61,
      62,    41,    42,    73,    79,    74,    51,    52,    53,    54,
      55,    56,   101,    57,    86,    95,    87,    88,    89,    90,
      58,    59,     8
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      19,    50,    60,    63,    91,    11,    94,     1,    91,     4,
     102,     7,    91,    18,     7,   103,    19,    91,   105,    22,
      91,    11,     5,    84,    85,    11,    47,    67,    78,    11,
      69,    45,    11,    47,   111,   112,    91,    91,    48,    11,
      47,   114,     9,    91,   116,    48,    91,    98,    72,    20,
      77,    49,    48,    97,    63,    11,    47,    75,    49,    11,
      47,    21,    23,    96,    64,    49,    76,    11,    48,   117,
      65,    43,    48,    12,    13,    11,    46,    84,    85,    81,
     106,    49,    82,    98,   107,    49,    99,   100,    12,    13,
       7,    28,    29,    24,    25,    80,    12,    13,    30,    31,
     118,    92,   120,    83,    93,    93,    26,    27,   113,    69,
      70,    71,   115,   108,   109,   119,    66,    44,     0,   104,
     110
};

static const yytype_int8 yycheck[] =
{
       9,    28,    29,    31,    67,     3,    71,     0,    71,     0,
      75,     3,    75,     9,     3,    80,    25,    80,    83,    11,
      83,     3,     7,     5,     6,     3,     4,    25,    55,     3,
      39,    27,     3,     4,    99,   100,    99,   100,    16,     3,
       4,   106,    22,   106,   109,    16,   109,    74,    26,    21,
      21,    29,    16,    17,    82,     3,     4,    22,    29,     3,
       4,    12,    13,    72,    21,    29,    21,     3,    16,    17,
       8,    22,    16,     9,    10,     3,    27,     5,     6,    21,
      26,    29,    24,   110,    93,    29,    14,    15,     9,    10,
       3,    12,    13,    23,    24,    18,     9,    10,    19,    20,
      27,    21,    21,    28,    24,    24,    23,    24,    23,   118,
      21,    22,    21,    23,    24,   118,    34,    25,    -1,    82,
      96
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     0,    31,    32,     0,     7,    33,     3,    72,    22,
      34,     3,     9,    10,    35,    36,    37,    38,    39,    71,
      21,    72,    11,    72,    23,    24,    23,    24,    12,    13,
      19,    20,    39,    40,    41,    42,    43,    44,    45,    46,
      48,    51,    52,    72,    36,    39,    72,     4,    16,    29,
      53,    56,    57,    58,    59,    60,    61,    63,    70,    71,
      53,    49,    50,    63,    21,     8,    42,    25,    47,    71,
      21,    22,    26,    53,    55,    22,    21,    21,    53,    54,
      18,    21,    24,    28,     5,     6,    64,    66,    67,    68,
      69,    70,    21,    24,    64,    65,    71,    17,    53,    14,
      15,    62,    64,    64,    50,    64,    26,    71,    23,    24,
      55,    64,    64,    23,    64,    21,    64,    17,    27,    47,
      21
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    30,    32,    31,    31,    33,    34,    34,    34,    35,
      35,    36,    37,    38,    38,    38,    39,    39,    39,    40,
      40,    41,    41,    42,    42,    43,    43,    43,    43,    44,
      45,    45,    46,    47,    47,    48,    49,    49,    50,    51,
      52,    53,    53,    53,    53,    54,    54,    55,    55,    56,
      56,    57,    57,    58,    59,    60,    61,    62,    62,    62,
      63,    64,    64,    65,    65,    66,    67,    67,    68,    69,
      70,    71,    72
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     1,     6,     3,     3,     0,     3,
       1,     1,     1,     3,     3,     1,     2,     2,     3,     1,
       0,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       3,     8,     1,     3,     1,     3,     1,     3,     3,     2,
       2,     1,     2,     1,     1,     1,     1,     2,     1,     2,
       5,     3,     5,     3,     2,     1,     4,     1,     2,     2,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= tEOF)
    {
      yychar = tEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 162 "../src/vlog/vlog-parse.y"
                { root = vlog_new(V_MODULE); }
#line 1797 "src/vlog/vlog-parse.c"
    break;

  case 3: /* description: $@1 module_declaration  */
#line 162 "../src/vlog/vlog-parse.y"
                                                                  { YYACCEPT; }
#line 1803 "src/vlog/vlog-parse.c"
    break;

  case 4: /* description: "end of file"  */
#line 163 "../src/vlog/vlog-parse.y"
                     { root = NULL; }
#line 1809 "src/vlog/vlog-parse.c"
    break;

  case 5: /* module_declaration: "module" external_identifier module_port_list_opt ';' module_item_list_opt "endmodule"  */
#line 169 "../src/vlog/vlog-parse.y"
                {
                   ident_t qual = ident_prefix(lib_name(lib_work()),
                                               (yyvsp[-4].pair).right, '.');

                   (yyval.vlog) = root;
                   vlog_set_ident((yyval.vlog), qual);
                   vlog_set_ident2((yyval.vlog), (yyvsp[-4].pair).left);
                   vlog_set_loc((yyval.vlog), &(yyloc));

                   for (node_list_t *it = (yyvsp[-3].list); it; it = it->next)
                      add_port((yyval.vlog), it->value);
                   node_list_free((yyvsp[-3].list));

                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next) {
                      if (is_decl(it->value))
                         vlog_add_decl((yyval.vlog), it->value);
                      else
                         vlog_add_stmt((yyval.vlog), it->value);
                   }
                   node_list_free((yyvsp[-1].list));
                }
#line 1835 "src/vlog/vlog-parse.c"
    break;

  case 6: /* module_port_list_opt: '(' list_of_port_declarations ')'  */
#line 193 "../src/vlog/vlog-parse.y"
                                                  { (yyval.list) = (yyvsp[-1].list); }
#line 1841 "src/vlog/vlog-parse.c"
    break;

  case 7: /* module_port_list_opt: '(' list_of_ports ')'  */
#line 194 "../src/vlog/vlog-parse.y"
                                      { (yyval.list) = (yyvsp[-1].list); }
#line 1847 "src/vlog/vlog-parse.c"
    break;

  case 8: /* module_port_list_opt: %empty  */
#line 195 "../src/vlog/vlog-parse.y"
                            { (yyval.list) = NULL; }
#line 1853 "src/vlog/vlog-parse.c"
    break;

  case 9: /* list_of_ports: list_of_ports ',' port  */
#line 199 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 1862 "src/vlog/vlog-parse.c"
    break;

  case 10: /* list_of_ports: port  */
#line 203 "../src/vlog/vlog-parse.y"
                     { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 1868 "src/vlog/vlog-parse.c"
    break;

  case 11: /* port: port_reference  */
#line 206 "../src/vlog/vlog-parse.y"
                               { (yyval.vlog) = (yyvsp[0].vlog); }
#line 1874 "src/vlog/vlog-parse.c"
    break;

  case 12: /* port_reference: identifier  */
#line 210 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_REF);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[0].ident));
                }
#line 1884 "src/vlog/vlog-parse.c"
    break;

  case 13: /* list_of_port_declarations: list_of_port_declarations ',' external_identifier  */
#line 219 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t p = vlog_new(V_PORT_DECL);
                   vlog_set_loc(p, &(yylsp[0]));
                   vlog_set_ident(p, (yyvsp[0].pair).left);
                   vlog_set_ident2(p, (yyvsp[0].pair).right);
                   vlog_set_subkind(p, vlog_subkind((yyvsp[-2].list)->tail->value));

                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), p);
                }
#line 1899 "src/vlog/vlog-parse.c"
    break;

  case 14: /* list_of_port_declarations: list_of_port_declarations ',' port_declaration  */
#line 230 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 1908 "src/vlog/vlog-parse.c"
    break;

  case 15: /* list_of_port_declarations: port_declaration  */
#line 234 "../src/vlog/vlog-parse.y"
                                 { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 1914 "src/vlog/vlog-parse.c"
    break;

  case 16: /* port_declaration: "input" external_identifier  */
#line 239 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_PORT_DECL);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[0].pair).left);
                   vlog_set_ident2((yyval.vlog), (yyvsp[0].pair).right);
                   vlog_set_subkind((yyval.vlog), V_PORT_INPUT);
                }
#line 1926 "src/vlog/vlog-parse.c"
    break;

  case 17: /* port_declaration: "output" external_identifier  */
#line 247 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_PORT_DECL);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[0].pair).left);
                   vlog_set_ident2((yyval.vlog), (yyvsp[0].pair).right);
                   vlog_set_subkind((yyval.vlog), V_PORT_OUTPUT);
                }
#line 1938 "src/vlog/vlog-parse.c"
    break;

  case 18: /* port_declaration: "output" "reg" external_identifier  */
#line 255 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_PORT_DECL);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[0].pair).left);
                   vlog_set_ident2((yyval.vlog), (yyvsp[0].pair).right);
                   vlog_set_subkind((yyval.vlog), V_PORT_OUTPUT_REG);
                }
#line 1950 "src/vlog/vlog-parse.c"
    break;

  case 20: /* module_item_list_opt: %empty  */
#line 266 "../src/vlog/vlog-parse.y"
                            { (yyval.list) = NULL; }
#line 1956 "src/vlog/vlog-parse.c"
    break;

  case 21: /* module_item_list: module_item_list module_item  */
#line 271 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-1].list);
                   node_list_concat(&(yyval.list), (yyvsp[0].list));
                }
#line 1965 "src/vlog/vlog-parse.c"
    break;

  case 24: /* module_item: port_declaration ';'  */
#line 281 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[-1].vlog));
                }
#line 1974 "src/vlog/vlog-parse.c"
    break;

  case 26: /* module_or_generate_item: always_construct  */
#line 289 "../src/vlog/vlog-parse.y"
                                 { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 1980 "src/vlog/vlog-parse.c"
    break;

  case 27: /* module_or_generate_item: initial_construct  */
#line 290 "../src/vlog/vlog-parse.y"
                                  { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 1986 "src/vlog/vlog-parse.c"
    break;

  case 30: /* net_declaration: net_type list_of_net_identifiers ';'  */
#line 300 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-1].list);
                }
#line 1994 "src/vlog/vlog-parse.c"
    break;

  case 31: /* net_declaration: net_type '[' expression ':' expression ']' list_of_net_identifiers ';'  */
#line 305 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-1].list);
                }
#line 2002 "src/vlog/vlog-parse.c"
    break;

  case 32: /* net_type: "wire"  */
#line 310 "../src/vlog/vlog-parse.y"
                      { (yyval.kind) = V_NET_WIRE; }
#line 2008 "src/vlog/vlog-parse.c"
    break;

  case 33: /* list_of_net_identifiers: list_of_net_identifiers ',' identifier  */
#line 315 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t v = vlog_new(V_NET_DECL);
                   vlog_set_loc(v, &(yylsp[0]));
                   vlog_set_ident(v, (yyvsp[0].ident));

                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), v);
                }
#line 2021 "src/vlog/vlog-parse.c"
    break;

  case 34: /* list_of_net_identifiers: identifier  */
#line 324 "../src/vlog/vlog-parse.y"
                {
                   vlog_node_t v = vlog_new(V_NET_DECL);
                   vlog_set_loc(v, &(yyloc));
                   vlog_set_ident(v, (yyvsp[0].ident));

                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), v);
                }
#line 2034 "src/vlog/vlog-parse.c"
    break;

  case 35: /* continuous_assign: "assign" list_of_net_assignments ';'  */
#line 335 "../src/vlog/vlog-parse.y"
                                                    { (yyval.list) = (yyvsp[-1].list); }
#line 2040 "src/vlog/vlog-parse.c"
    break;

  case 36: /* list_of_net_assignments: net_assignment  */
#line 339 "../src/vlog/vlog-parse.y"
                               { (yyval.list) = node_list_single((yyvsp[0].vlog)); }
#line 2046 "src/vlog/vlog-parse.c"
    break;

  case 37: /* list_of_net_assignments: list_of_net_assignments ',' net_assignment  */
#line 341 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2055 "src/vlog/vlog-parse.c"
    break;

  case 38: /* net_assignment: lvalue '=' expression  */
#line 348 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_ASSIGN);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_target((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2066 "src/vlog/vlog-parse.c"
    break;

  case 39: /* always_construct: "always" statement  */
#line 358 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_ALWAYS);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_add_stmt((yyval.vlog), (yyvsp[0].vlog));

                   char *name LOCAL =
                      xasprintf("__always#line%d", (yyloc).first_line);
                   vlog_set_ident((yyval.vlog), ident_uniq(name));
                }
#line 2080 "src/vlog/vlog-parse.c"
    break;

  case 40: /* initial_construct: "initial" statement  */
#line 371 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_INITIAL);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_add_stmt((yyval.vlog), (yyvsp[0].vlog));

                   char *name LOCAL =
                      xasprintf("__initial#line%d", (yyloc).first_line);
                   vlog_set_ident((yyval.vlog), ident_uniq(name));
                }
#line 2094 "src/vlog/vlog-parse.c"
    break;

  case 46: /* statement_or_null: ';'  */
#line 390 "../src/vlog/vlog-parse.y"
                    { (yyval.vlog) = NULL; }
#line 2100 "src/vlog/vlog-parse.c"
    break;

  case 47: /* list_of_statements: list_of_statements statement  */
#line 395 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-1].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2109 "src/vlog/vlog-parse.c"
    break;

  case 48: /* list_of_statements: statement  */
#line 400 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2118 "src/vlog/vlog-parse.c"
    break;

  case 49: /* system_task_enable: "system task identifier" ';'  */
#line 408 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SYSTASK);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), ident_new((yyvsp[-1].str)));

                   free((yyvsp[-1].str));
                }
#line 2130 "src/vlog/vlog-parse.c"
    break;

  case 50: /* system_task_enable: "system task identifier" '(' list_of_expressions ')' ';'  */
#line 416 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SYSTASK);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), ident_new((yyvsp[-4].str)));

                   for (node_list_t *it = (yyvsp[-2].list); it; it = it->next)
                      vlog_add_param((yyval.vlog), it->value);
                   node_list_free((yyvsp[-2].list));

                   free((yyvsp[-4].str));
                }
#line 2146 "src/vlog/vlog-parse.c"
    break;

  case 51: /* seq_block: "begin" list_of_statements "end"  */
#line 430 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SEQ_BLOCK);
                   vlog_set_loc((yyval.vlog), &(yyloc));

                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next)
                      vlog_add_stmt((yyval.vlog), it->value);
                   node_list_free((yyvsp[-1].list));
                }
#line 2159 "src/vlog/vlog-parse.c"
    break;

  case 52: /* seq_block: "begin" ':' identifier list_of_statements "end"  */
#line 439 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_SEQ_BLOCK);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[-2].ident));

                   for (node_list_t *it = (yyvsp[-1].list); it; it = it->next)
                      vlog_add_stmt((yyval.vlog), it->value);
                   node_list_free((yyvsp[-1].list));
                }
#line 2173 "src/vlog/vlog-parse.c"
    break;

  case 53: /* nonblocking_assignment: lvalue "<=" expression  */
#line 452 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_NBASSIGN);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_target((yyval.vlog), (yyvsp[-2].vlog));
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2184 "src/vlog/vlog-parse.c"
    break;

  case 54: /* procedural_timing_control_statement: delay_or_event_control statement_or_null  */
#line 462 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_TIMING);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_value((yyval.vlog), (yyvsp[-1].vlog));
                   if ((yyvsp[0].vlog) != NULL)
                      vlog_add_stmt((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2196 "src/vlog/vlog-parse.c"
    break;

  case 56: /* event_control: '@' '(' event_expression ')'  */
#line 475 "../src/vlog/vlog-parse.y"
                                            { (yyval.vlog) = (yyvsp[-1].vlog); }
#line 2202 "src/vlog/vlog-parse.c"
    break;

  case 57: /* event_expression: expression  */
#line 479 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_EVENT);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_EVENT_LEVEL);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2213 "src/vlog/vlog-parse.c"
    break;

  case 58: /* event_expression: "posedge" expression  */
#line 486 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_EVENT);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_EVENT_POSEDGE);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2224 "src/vlog/vlog-parse.c"
    break;

  case 59: /* event_expression: "negedge" expression  */
#line 493 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_EVENT);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_subkind((yyval.vlog), V_EVENT_NEGEDGE);
                   vlog_set_value((yyval.vlog), (yyvsp[0].vlog));
                }
#line 2235 "src/vlog/vlog-parse.c"
    break;

  case 60: /* lvalue: hierarchical_identifier  */
#line 502 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_REF);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_ident((yyval.vlog), (yyvsp[0].ident));
                }
#line 2245 "src/vlog/vlog-parse.c"
    break;

  case 63: /* list_of_expressions: list_of_expressions ',' expression  */
#line 515 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = (yyvsp[-2].list);
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2254 "src/vlog/vlog-parse.c"
    break;

  case 64: /* list_of_expressions: expression  */
#line 520 "../src/vlog/vlog-parse.y"
                {
                   (yyval.list) = NULL;
                   node_list_append(&(yyval.list), (yyvsp[0].vlog));
                }
#line 2263 "src/vlog/vlog-parse.c"
    break;

  case 65: /* string: "string"  */
#line 527 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_STRING);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   (yyvsp[0].str)[strlen((yyvsp[0].str)) - 1] = '\0';
                   vlog_set_text((yyval.vlog), (yyvsp[0].str) + 1);
                   free((yyvsp[0].str));
                }
#line 2275 "src/vlog/vlog-parse.c"
    break;

  case 66: /* primary: hierarchical_identifier  */
#line 537 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_REF);
                   vlog_set_ident((yyval.vlog), (yyvsp[0].ident));
                   vlog_set_loc((yyval.vlog), &(yyloc));
                }
#line 2285 "src/vlog/vlog-parse.c"
    break;

  case 69: /* decimal_number: "unsigned number"  */
#line 549 "../src/vlog/vlog-parse.y"
                {
                   (yyval.vlog) = vlog_new(V_NUMBER);
                   vlog_set_loc((yyval.vlog), &(yyloc));
                   vlog_set_number((yyval.vlog), number_new((yyvsp[0].str)));
                   free((yyvsp[0].str));
                }
#line 2296 "src/vlog/vlog-parse.c"
    break;

  case 71: /* identifier: "identifier"  */
#line 562 "../src/vlog/vlog-parse.y"
                {
                   (yyval.ident) = ident_new((yyvsp[0].str));
                   free((yyvsp[0].str));
                }
#line 2305 "src/vlog/vlog-parse.c"
    break;

  case 72: /* external_identifier: "identifier"  */
#line 570 "../src/vlog/vlog-parse.y"
                {
                   (yyval.pair).left = ident_new((yyvsp[0].str));
                   for (char *p = (yyvsp[0].str); *p; p++)
                      *p = toupper_iso88591(*p);
                   (yyval.pair).right = ident_new((yyvsp[0].str));
                   free((yyvsp[0].str));
                }
#line 2317 "src/vlog/vlog-parse.c"
    break;


#line 2321 "src/vlog/vlog-parse.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= tEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == tEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 579 "../src/vlog/vlog-parse.y"


static void yyerror(const char *s)
{
   error_at(&yylloc, "%s", s);
}

static void node_list_concat(node_list_t **a, node_list_t *b)
{
   if (*a == NULL)
      *a = b;
   else if (b != NULL) {
      assert((*a)->tail->next == NULL);
      (*a)->tail->next = b;
      (*a)->tail = b->tail;
   }
}

static void node_list_free(node_list_t *l)
{
   while (l != NULL) {
      node_list_t *next = l->next;
      free(l);
      l = next;
   }
}

static void node_list_append(node_list_t **l, vlog_node_t v)
{
   node_list_t *new = xmalloc(sizeof(node_list_t));
   new->next  = NULL;
   new->value = v;
   new->tail  = new;

   node_list_concat(l, new);
}

static node_list_t *node_list_single(vlog_node_t v)
{
   node_list_t *new = xmalloc(sizeof(node_list_t));
   new->next  = NULL;
   new->value = v;
   new->tail  = new;

   return new;
}

vlog_node_t vlog_parse(void)
{
   make_new_arena();
   root = NULL;

   scan_as_verilog();

   if (yyparse())
      return NULL;
   else
      return root;
}

void reset_verilog_parser(void)
{
}
